#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include "jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper.h"


/***  GLOBAL VARIABLES ***/
int            morphyUsbIoFd;
unsigned char *morphyUsbIoMappedMemory;

/*
 *   Class:     jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper
 *   Method:    prepareMorphyUsbIo
 *   Signature: ()I
 */
JNIEXPORT jint JNICALL Java_jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper_prepareMorphyUsbIo
  (JNIEnv *env, jobject obj)
{
    morphyUsbIoFd = open("/sdcard/tempIPC.tmp", O_RDWR);
    if (morphyUsbIoFd < 0)
    {
      morphyUsbIoMappedMemory = NULL;
      return (-1);
    }

    morphyUsbIoMappedMemory = NULL;
    morphyUsbIoMappedMemory = mmap(NULL, (sizeof(unsigned char) * 3), PROT_WRITE, MAP_SHARED, morphyUsbIoFd, 0);
    if ((morphyUsbIoMappedMemory == MAP_FAILED)||(morphyUsbIoMappedMemory == NULL))
    {
        morphyUsbIoMappedMemory = NULL;
        return (-2);
    }

    morphyUsbIoMappedMemory[0] = 0;
    morphyUsbIoMappedMemory[1] = 0xff;
    morphyUsbIoMappedMemory[2] = 0xff;

    return (0);
}

/*
 *   Class:     jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper
 *   Method:    outputMorphyUsbIo
 *   Signature: (II)V
 */
JNIEXPORT void JNICALL Java_jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper_outputMorphyUsbIo
  (JNIEnv *env, jobject obj, jint port, jint value)
{
    unsigned char data = (unsigned char) (value & 0x000000ff);

    if (morphyUsbIoMappedMemory == NULL)
    {
        return;
    }

    if (port == 0)
    {
        morphyUsbIoMappedMemory[1] = data;
    }
    else if (port == 1)
    {
        morphyUsbIoMappedMemory[2] = data;
    }

    if (morphyUsbIoMappedMemory[0] == 0xa4)
    {
        morphyUsbIoMappedMemory[0] = 0x4a;
    }
    else if (morphyUsbIoMappedMemory[0] == 0x4a)
    {
        morphyUsbIoMappedMemory[0] = 0xed;
    }
    else // if (morphyUsbIoMappedMemory[0] == 0xed)
    {
        morphyUsbIoMappedMemory[0] = 0xa4;
    }
    return;
}

/*
 *   Class:     jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper
 *   Method:    inputMorphyUsbIo
 *   Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper_inputMorphyUsbIo
  (JNIEnv *env, jobject obj, jint port)
{
    /*** DUMMY FUNCTION (FUTURE RESERVE) ***/
    return (0);
}

/*
 *   Class:     jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper
 *   Method:    shutdownMorphyUsbIo
 *   Signature: ()V
 */
JNIEXPORT void JNICALL Java_jp_sourceforge_gokigen_usbiowrapper_LibUsbGokigenWrapper_shutdownMorphyUsbIo
  (JNIEnv *env, jobject obj)
{
    if (morphyUsbIoMappedMemory != NULL)
    {
        morphyUsbIoMappedMemory[0] = 0x78;
        munmap(morphyUsbIoMappedMemory, (sizeof(unsigned char) * 3));
    }
    if (morphyUsbIoFd >= 0)
    {
        close(morphyUsbIoFd);
    }

    morphyUsbIoMappedMemory = NULL;
    morphyUsbIoFd = -1;
    return;
}


